Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/Makefile
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/Makefile	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/Makefile	(revision 464)
@@ -99,4 +99,5 @@
 OBJECTS += certs/certs.o
 OBJECTS += deps/parson/parson.o
+OBJECTS += deps/uhttp/src/uhttp.o
 OBJECTS += iothub_client/src/blob.o
 OBJECTS += iothub_client/src/iothub.o
@@ -144,5 +145,4 @@
 OBJECTS += serializer/src/codefirst.o
 OBJECTS += serializer/src/commanddecoder.o
-OBJECTS += uhttp/src/uhttp.o
 OBJECTS += umqtt/src/mqtt_client.o
 OBJECTS += umqtt/src/mqtt_codec.o
@@ -171,11 +171,11 @@
 INCLUDE_PATHS += -I../../azure_iot_sdk/deps/parson
 INCLUDE_PATHS += -I../../azure_iot_sdk/deps/azure-macro-utils-c/inc
+INCLUDE_PATHS += -I../../azure_iot_sdk/deps/uhttp/inc
 INCLUDE_PATHS += -I../../azure_iot_sdk/deps/umock-c/inc
 INCLUDE_PATHS += -I../../azure_iot_sdk/serializer/inc
-INCLUDE_PATHS += -I../../azure_iot_sdk/uhttp/inc
 INCLUDE_PATHS += -I../../azure_iot_sdk/umqtt/inc
-INCLUDE_PATHS += -I../../wolfssl-4.4.0/wolfssl
-INCLUDE_PATHS += -I../../wolfssl-4.4.0/wolfssl/wolfcrypt
-INCLUDE_PATHS += -I../../wolfssl-4.4.0
+INCLUDE_PATHS += -I../../wolfssl-4.7.0/wolfssl
+INCLUDE_PATHS += -I../../wolfssl-4.7.0/wolfssl/wolfcrypt
+INCLUDE_PATHS += -I../../wolfssl-4.7.0
 INCLUDE_PATHS += -I../../zlib-1.2.11/src
 
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/httpapi_compact.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/httpapi_compact.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/httpapi_compact.c	(revision 464)
@@ -51,8 +51,4 @@
     char*           x509ClientCertificate;
     char*           x509ClientPrivateKey;
-    const char*     proxy_host;
-    int             proxy_port;
-    const char*     proxy_username;
-    const char*     proxy_password;
     XIO_HANDLE      xio_handle;
     size_t          received_bytes_count;
@@ -205,4 +201,5 @@
 {
     HTTP_HANDLE_DATA* http_instance;
+    TLSIO_CONFIG tlsio_config;
 
     if (hostName == NULL)
@@ -226,7 +223,7 @@
             LogError("There is no memory to control the http connection");
         }
-        else if(mallocAndStrcpy_s((char**)&(http_instance->hostName), hostName) != 0)
-        {
-            LogError("failure allocate host name");
+        else if (mallocAndStrcpy_s(&http_instance->hostName, hostName) != 0)
+        {
+            LogError("Failed copying hostname");
             free(http_instance);
             http_instance = NULL;
@@ -234,16 +231,29 @@
         else
         {
-            http_instance->xio_handle = NULL;
-            http_instance->is_connected = 0;
-            http_instance->is_io_error = 0;
-            http_instance->received_bytes_count = 0;
-            http_instance->received_bytes = NULL;
-            http_instance->certificate = NULL;
-            http_instance->x509ClientCertificate = NULL;
-            http_instance->x509ClientPrivateKey = NULL;
-            http_instance->proxy_host = NULL;
-            http_instance->proxy_port = 0;
-            http_instance->proxy_username = NULL;
-            http_instance->proxy_password = NULL;
+            tlsio_config.hostname = http_instance->hostName;
+            tlsio_config.port = 443;
+            tlsio_config.underlying_io_interface = NULL;
+            tlsio_config.underlying_io_parameters = NULL;
+
+            http_instance->xio_handle = xio_create(platform_get_default_tlsio(), (void*)&tlsio_config);
+
+            /*Codes_SRS_HTTPAPI_COMPACT_21_016: [ If the HTTPAPI_CreateConnection failed to create the connection, it shall return NULL as the handle. ]*/
+            if (http_instance->xio_handle == NULL)
+            {
+                LogError("Create connection failed");
+                free(http_instance->hostName);
+                free(http_instance);
+                http_instance = NULL;
+            }
+            else
+            {
+                http_instance->is_connected = 0;
+                http_instance->is_io_error = 0;
+                http_instance->received_bytes_count = 0;
+                http_instance->received_bytes = NULL;
+                http_instance->certificate = NULL;
+                http_instance->x509ClientCertificate = NULL;
+                http_instance->x509ClientPrivateKey = NULL;
+            }
         }
     }
@@ -311,9 +321,4 @@
         }
 
-        if (http_instance->hostName != NULL)
-        {
-            free((void*)http_instance->hostName);
-        }
-
 #ifndef DO_NOT_COPY_TRUSTED_CERTS_STRING
         /*Codes_SRS_HTTPAPI_COMPACT_21_018: [ If there is a certificate associated to this connection, the HTTPAPI_CloseConnection shall free all allocated memory for the certificate. ]*/
@@ -336,15 +341,7 @@
         }
 
-        if (http_instance->proxy_host != NULL)
-        {
-            free((void*)http_instance->proxy_host);
-        }
-        if (http_instance->proxy_username != NULL)
-        {
-            free((void*)http_instance->proxy_username);
-        }
-        if (http_instance->proxy_password != NULL)
-        {
-            free((void*)http_instance->proxy_password);
+        if (http_instance->hostName)
+        {
+            free(http_instance->hostName);
         }
 
@@ -714,6 +711,4 @@
 {
     HTTPAPI_RESULT result;
-    TLSIO_CONFIG tlsio_config;
-    HTTP_PROXY_IO_CONFIG http_proxy_io_config;
 
     if (http_instance->is_connected != 0)
@@ -725,39 +720,7 @@
     {
         http_instance->is_io_error = 0;
-        tlsio_config.hostname = http_instance->hostName;
-        tlsio_config.port = 443;
-
-        if (http_instance->proxy_host != NULL) {
-            tlsio_config.underlying_io_interface = http_proxy_io_get_interface_description();
-        }
-        else {
-            tlsio_config.underlying_io_interface = NULL;
-        }
-
-        if (tlsio_config.underlying_io_interface != NULL) {
-            tlsio_config.underlying_io_parameters = (void*)&http_proxy_io_config;
-
-            http_proxy_io_config.proxy_hostname = http_instance->proxy_host;
-            http_proxy_io_config.proxy_port = http_instance->proxy_port;
-            http_proxy_io_config.username = http_instance->proxy_username;
-            http_proxy_io_config.password = http_instance->proxy_password;
-            http_proxy_io_config.hostname = http_instance->hostName;
-            http_proxy_io_config.port = 443;
-        }
-        else {
-            tlsio_config.underlying_io_parameters = NULL;
-        }
-
-        http_instance->xio_handle = xio_create(platform_get_default_tlsio(), (void*)&tlsio_config);
-
-        if (http_instance->xio_handle == NULL)
-        {
-            LogError("Create connection failed");
-            free(http_instance);
-            http_instance = NULL;
-            result = HTTPAPI_ERROR;
-        }
+
         /*Codes_SRS_HTTPAPI_COMPACT_21_022: [ If a Certificate was provided, the HTTPAPI_ExecuteRequest shall set this option on the transport layer. ]*/
-        else if ((http_instance->certificate != NULL) &&
+        if ((http_instance->certificate != NULL) &&
             (xio_setoption(http_instance->xio_handle, OPTION_TRUSTED_CERT, http_instance->certificate) != 0))
         {
@@ -777,4 +740,5 @@
             (xio_setoption(http_instance->xio_handle, SU_OPTION_X509_PRIVATE_KEY, http_instance->x509ClientPrivateKey) != 0))
         {
+
             /*Codes_SRS_HTTPAPI_COMPACT_06_006: [ If the transport failed setting the client certificate private key, the HTTPAPI_ExecuteRequest shall not send any request and return HTTPAPI_SET_OPTION_FAILED. ] */
             result = HTTPAPI_SET_OPTION_FAILED;
@@ -800,5 +764,5 @@
                 {
                     xio_dowork(http_instance->xio_handle);
-                    //LogInfo("Waiting for TLS connection");
+                    LogInfo("Waiting for TLS connection");
                     if ((countRetry--) < 0)
                     {
@@ -1347,5 +1311,5 @@
 #endif // DO_NOT_COPY_TRUSTED_CERTS_STRING
     }
-    else if (strcmp(SU_OPTION_X509_CERT, optionName) == 0)
+    else if (strcmp(SU_OPTION_X509_CERT, optionName) == 0 || strcmp(OPTION_X509_ECC_CERT, optionName) == 0)
     {
         int len;
@@ -1370,5 +1334,5 @@
         }
     }
-    else if (strcmp(SU_OPTION_X509_PRIVATE_KEY, optionName) == 0)
+    else if (strcmp(SU_OPTION_X509_PRIVATE_KEY, optionName) == 0 || strcmp(OPTION_X509_ECC_KEY, optionName) == 0)
     {
         int len;
@@ -1395,66 +1359,68 @@
     else if (strcmp(OPTION_HTTP_PROXY, optionName) == 0)
     {
-        HTTP_PROXY_OPTIONS* proxy_data = (HTTP_PROXY_OPTIONS*)value;
-        if (proxy_data->host_address == NULL || proxy_data->port <= 0)
-        {
-            LogError("invalid proxy_data values ( host_address = %p, port = %d)", proxy_data->host_address, proxy_data->port);
+        TLSIO_CONFIG tlsio_config;
+        HTTP_PROXY_IO_CONFIG proxy_config;
+        HTTP_PROXY_OPTIONS* proxy_options = (HTTP_PROXY_OPTIONS*)value;
+
+        if (proxy_options->host_address == NULL)
+        {
+            LogError("NULL host_address in proxy options");
             result = HTTPAPI_ERROR;
         }
+        else if (((proxy_options->username == NULL) || (proxy_options->password == NULL)) &&
+                (proxy_options->username != proxy_options->password))
+        {
+            LogError("Only one of username and password for proxy settings was NULL");
+            result = HTTPAPI_ERROR;
+        }
         else
         {
-            if(http_instance->proxy_host != NULL)
-            {
-                free((void*)http_instance->proxy_host);
-                http_instance->proxy_host = NULL;
-            }
-            if(mallocAndStrcpy_s((char**)&(http_instance->proxy_host), (const char*)proxy_data->host_address) != 0)
-            {
-                LogError("failure allocate proxy host");
+
+            /* Workaround: xio interface is already created when HTTPAPI_CreateConnection is call without proxy support
+             * need to destroy the interface and create a new one with proxy information
+             */
+            OPTIONHANDLER_HANDLE xio_options;
+            if ((xio_options = xio_retrieveoptions(http_instance->xio_handle)) == NULL)
+            {
+                LogError("failed saving underlying I/O transport options");
                 result = HTTPAPI_ERROR;
             }
             else
             {
-                http_instance->proxy_port = proxy_data->port;
-
-                if (proxy_data->username != NULL && proxy_data->password != NULL)
-                {
-                    if(http_instance->proxy_username != NULL)
+                xio_destroy(http_instance->xio_handle);
+
+                proxy_config.hostname = http_instance->hostName;
+                proxy_config.proxy_hostname = proxy_options->host_address;
+                proxy_config.password = proxy_options->password;
+                proxy_config.username = proxy_options->username;
+                proxy_config.proxy_port = proxy_options->port;
+                proxy_config.port = 443;
+
+                tlsio_config.hostname = http_instance->hostName;
+                tlsio_config.port = 443;
+                tlsio_config.underlying_io_interface =  http_proxy_io_get_interface_description();
+                tlsio_config.underlying_io_parameters = &proxy_config;
+
+                http_instance->xio_handle = xio_create(platform_get_default_tlsio(), (void*)&tlsio_config);
+
+                if (http_instance->xio_handle == NULL)
+                {
+                    LogError("Failed to create xio handle with proxy configuration");
+                    result = HTTPAPI_ERROR;
+                }
+                else
+                {
+                    if (OptionHandler_FeedOptions(xio_options, http_instance->xio_handle) != OPTIONHANDLER_OK)
                     {
-                        free((void*)http_instance->proxy_username);
-                        http_instance->proxy_username = NULL;
-                    }
-                    if(mallocAndStrcpy_s((char**)&(http_instance->proxy_username), (const char*)proxy_data->username) != 0)
-                    {
-                        LogError("failure allocate proxy username");
-                        free((void*)http_instance->proxy_host);
-                        http_instance->proxy_host = NULL;
+                        LogError("Failed feeding existing options to new xio instance.");
                         result = HTTPAPI_ERROR;
                     }
                     else
                     {
-                        if(http_instance->proxy_password != NULL)
-                        {
-                          free((void*)http_instance->proxy_password);
-                          http_instance->proxy_password = NULL;
-                        }
-                        if(mallocAndStrcpy_s((char**)&(http_instance->proxy_password), (const char*)proxy_data->password) != 0)
-                        {
-                            LogError("failure allocate proxy password");
-                            free((void*)http_instance->proxy_host);
-                            http_instance->proxy_host = NULL;
-                            free((void*)http_instance->proxy_username);
-                            http_instance->proxy_username = NULL;
-                            result = HTTPAPI_ERROR;
-                        }
-                        else
-                        {
-                          result = HTTPAPI_OK;
-                        }
+                        result = HTTPAPI_OK;
                     }
                 }
-                else
-                {
-                    result = HTTPAPI_OK;
-                }
+
+                OptionHandler_Destroy(xio_options);
             }
         }
@@ -1466,4 +1432,5 @@
         LogInfo("unknown option %s", optionName);
     }
+
     return result;
 }
@@ -1510,5 +1477,5 @@
 #endif // DO_NOT_COPY_TRUSTED_CERTS_STRING
     }
-    else if (strcmp(SU_OPTION_X509_CERT, optionName) == 0)
+    else if (strcmp(SU_OPTION_X509_CERT, optionName) == 0 || strcmp(OPTION_X509_ECC_CERT, optionName) == 0)
     {
         certLen = strlen((const char*)value);
@@ -1527,5 +1494,5 @@
         }
     }
-    else if (strcmp(SU_OPTION_X509_PRIVATE_KEY, optionName) == 0)
+    else if (strcmp(SU_OPTION_X509_PRIVATE_KEY, optionName) == 0 || strcmp(OPTION_X509_ECC_KEY, optionName) == 0)
     {
         certLen = strlen((const char*)value);
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/platform_toppers.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/platform_toppers.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/platform_toppers.c	(revision 464)
@@ -52,6 +52,6 @@
 const IO_INTERFACE_DESCRIPTION* platform_get_default_tlsio(void)
 {
-	//return tlsio_esp_at_get_interface_description();
-	return tlsio_wolfssl_get_interface_description();
+	return tlsio_esp_at_get_interface_description();
+	//return tlsio_wolfssl_get_interface_description();
 }
 
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/tlsio_wolfssl.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/tlsio_wolfssl.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/adapters/tlsio_wolfssl.c	(revision 464)
@@ -19,5 +19,4 @@
 #include "azure_c_shared_utility/xlogging.h"
 #include "azure_c_shared_utility/shared_util_options.h"
-#include "azure_c_shared_utility/threadapi.h"
 
 typedef enum TLSIO_STATE_ENUM_TAG
@@ -53,9 +52,10 @@
     char* x509privatekey;
     int wolfssl_device_id;
-    size_t socket_reads;
+    char* hostname;
+    bool ignore_host_name_check;
 } TLS_IO_INSTANCE;
 
 STATIC_VAR_UNUSED const char* const OPTION_WOLFSSL_SET_DEVICE_ID = "SetDeviceId";
-static const size_t SOCKET_READ_LIMIT = 10000; // 10,000 ms ?
+static const size_t SOCKET_READ_LIMIT = 5;
 
 /*this function will clone an option given by name and value*/
@@ -106,4 +106,21 @@
             }
         }
+        #ifdef INVALID_DEVID
+        else if(strcmp(name, OPTION_WOLFSSL_SET_DEVICE_ID) == 0 )
+        {
+             int* value_clone;
+
+             if ((value_clone = malloc(sizeof(int))) == NULL)
+             {
+                 LogError("unable to clone device id option");
+             }
+             else
+             {
+                 *value_clone = *(int*)value;
+             }
+
+             result = value_clone;
+        }
+        #endif
         else
         {
@@ -127,5 +144,6 @@
         if ((strcmp(name, OPTION_TRUSTED_CERT) == 0) ||
             (strcmp(name, SU_OPTION_X509_CERT) == 0) ||
-            (strcmp(name, SU_OPTION_X509_PRIVATE_KEY) == 0))
+            (strcmp(name, SU_OPTION_X509_PRIVATE_KEY) == 0) ||
+            (strcmp(name, OPTION_WOLFSSL_SET_DEVICE_ID) == 0))
         {
             free((void*)value);
@@ -185,4 +203,15 @@
                 result = NULL;
             }
+            #ifdef INVALID_DEVID
+            else if (
+                (tls_io_instance->wolfssl_device_id != INVALID_DEVID) &&
+                (OptionHandler_AddOption(result, OPTION_WOLFSSL_SET_DEVICE_ID, &tls_io_instance->wolfssl_device_id) != OPTIONHANDLER_OK)
+                )
+            {
+                LogError("unable to save deviceid option");
+                OptionHandler_Destroy(result);
+                result = NULL;
+            }
+            #endif
             else
             {
@@ -258,10 +287,10 @@
         int res;
         tls_io_instance->tlsio_state = TLSIO_STATE_IN_HANDSHAKE;
-        tls_io_instance->socket_reads = 0;
 
         res = wolfSSL_connect(tls_io_instance->ssl);
         if (res != SSL_SUCCESS)
         {
-            LogError("WolfSSL connect failed");
+            // Error codes explained in https://www.wolfssl.com/docs/wolfssl-manual/appendix-c/
+            LogError("WolfSSL connect failed (%d)", wolfSSL_get_error(tls_io_instance->ssl, res));
             indicate_open_complete(tls_io_instance, IO_OPEN_ERROR);
             tls_io_instance->tlsio_state = TLSIO_STATE_ERROR;
@@ -355,18 +384,15 @@
         TLS_IO_INSTANCE* tls_io_instance = (TLS_IO_INSTANCE*)context;
         unsigned char* new_socket_io_read_bytes;
+        size_t socket_reads = 0;
 
         AZURE_UNREFERENCED_PARAMETER(ssl);
-        if (tls_io_instance->socket_io_read_byte_count == 0)
-        {
-            if (tls_io_instance->socket_reads >= SOCKET_READ_LIMIT) {
-                return WOLFSSL_CBIO_ERR_TIMEOUT;
-            }
+        while (tls_io_instance->socket_io_read_byte_count == 0 && socket_reads < SOCKET_READ_LIMIT)
+        {
             xio_dowork(tls_io_instance->socket_io);
-            if (tls_io_instance->tlsio_state == TLSIO_STATE_IN_HANDSHAKE)
-            {
-                tls_io_instance->socket_reads++;
-                ThreadAPI_Sleep(1);
-                return 0;
-            }
+            if (tls_io_instance->tlsio_state != TLSIO_STATE_IN_HANDSHAKE)
+            {
+                break;
+            }
+            socket_reads++;
         }
 
@@ -417,29 +443,17 @@
 }
 
-static void on_send_complete(void* context, IO_SEND_RESULT send_result)
-{
-	TLS_IO_INSTANCE* tls_io_instance = (TLS_IO_INSTANCE*)context;
-	if ((tls_io_instance == NULL) || (tls_io_instance->on_send_complete == NULL))
-		return;
-
-	tls_io_instance->on_send_complete(tls_io_instance->on_send_complete_callback_context, send_result);
-
-	tls_io_instance->on_send_complete = NULL;
-	tls_io_instance->on_send_complete_callback_context = NULL;
-}
-
 static int on_io_send(WOLFSSL *ssl, char *buf, int sz, void *context)
 {
-    int result, ret;
+    int result;
     AZURE_UNREFERENCED_PARAMETER(ssl);
 
     TLS_IO_INSTANCE* tls_io_instance = (TLS_IO_INSTANCE*)context;
 
-    if ((ret = xio_send(tls_io_instance->socket_io, buf, sz, on_send_complete, tls_io_instance)) != 0)
-    {
-        LogError("Failed sending bytes through underlying IO %d", ret);
+    if (xio_send(tls_io_instance->socket_io, buf, sz, tls_io_instance->on_send_complete, tls_io_instance->on_send_complete_callback_context) != 0)
+    {
+        LogError("Failed sending bytes through underlying IO");
         tls_io_instance->tlsio_state = TLSIO_STATE_ERROR;
         indicate_error(tls_io_instance);
-        result = 0;
+        result = WOLFSSL_CBIO_ERR_GENERAL;
     }
     else
@@ -455,8 +469,5 @@
     AZURE_UNREFERENCED_PARAMETER(ssl);
     TLS_IO_INSTANCE* tls_io_instance = (TLS_IO_INSTANCE*)context;
-    if (tls_io_instance->tlsio_state == TLSIO_STATE_OPEN) {
-        LogInfo("on_handshake_done called in TLSIO_STATE_OPEN state");
-    }
-    else if (tls_io_instance->tlsio_state != TLSIO_STATE_IN_HANDSHAKE)
+    if (tls_io_instance->tlsio_state != TLSIO_STATE_IN_HANDSHAKE)
     {
         LogInfo("on_handshake_done called when not in IN_HANDSHAKE state");
@@ -558,8 +569,29 @@
 }
 
+static int enable_domain_check(TLS_IO_INSTANCE* tls_io_instance)
+{
+    int result = 0;
+
+    if (!tls_io_instance->ignore_host_name_check)
+    {
+        if (wolfSSL_check_domain_name(tls_io_instance->ssl, tls_io_instance->hostname) != WOLFSSL_SUCCESS)
+        {
+            result = MU_FAILURE;
+        }
+    }
+
+    return result;
+}
+
 static int prepare_wolfssl_open(TLS_IO_INSTANCE* tls_io_instance)
 {
     int result;
-    if (add_certificate_to_store(tls_io_instance) != 0)
+
+    if (enable_domain_check(tls_io_instance))
+    {
+        LogError("Failed to configure domain name verification");
+        result = MU_FAILURE;
+    }
+    else if (add_certificate_to_store(tls_io_instance) != 0)
     {
         LogError("Failed to add certificates to store");
@@ -575,11 +607,4 @@
         result = MU_FAILURE;
     }
-#ifdef INVALID_DEVID
-    else if (tls_io_instance->wolfssl_device_id != INVALID_DEVID && wolfSSL_SetDevId(tls_io_instance->ssl, tls_io_instance->wolfssl_device_id) != WOLFSSL_SUCCESS)
-    {
-        LogError("Failure setting device id");
-        result = MU_FAILURE;
-    }
-#endif
     else
     {
@@ -628,4 +653,10 @@
             {
                 LogError("Cannot create the wolfSSL context");
+                free(result);
+                result = NULL;
+            }
+            else if (mallocAndStrcpy_s(&result->hostname, tls_io_config->hostname) != 0)
+            {
+                LogError("Failed copying the target hostname.");
                 free(result);
                 result = NULL;
@@ -660,4 +691,5 @@
                     LogError("Failed getting socket IO interface description.");
                     wolfSSL_CTX_free(result->ssl_context);
+                    free(result->hostname);
                     free(result);
                     result = NULL;
@@ -670,4 +702,5 @@
                         LogError("Failure connecting to underlying socket_io");
                         wolfSSL_CTX_free(result->ssl_context);
+                        free(result->hostname);
                         free(result);
                         result = NULL;
@@ -677,4 +710,5 @@
                         LogError("Failure connecting to underlying socket_io");
                         wolfSSL_CTX_free(result->ssl_context);
+                        free(result->hostname);
                         free(result);
                         result = NULL;
@@ -719,4 +753,5 @@
 
         xio_destroy(tls_io_instance->socket_io);
+        free(tls_io_instance->hostname);
         free(tls_io);
     }
@@ -843,9 +878,4 @@
             result = MU_FAILURE;
         }
-        if (tls_io_instance->on_send_complete != NULL)
-        {
-            LogError("Error writing data");
-            result = MU_FAILURE;
-        }
         else
         {
@@ -882,6 +912,5 @@
             (tls_io_instance->tlsio_state != TLSIO_STATE_ERROR))
         {
-            if (tls_io_instance->tlsio_state != TLSIO_STATE_OPENING_UNDERLYING_IO)
-                decode_ssl_received_bytes(tls_io_instance);
+            decode_ssl_received_bytes(tls_io_instance);
             xio_dowork(tls_io_instance->socket_io);
         }
@@ -892,4 +921,7 @@
 static int process_option(char** destination, const char* name, const char* value)
 {
+
+    (void) name;
+    
     int result;
     if (*destination != NULL)
@@ -944,19 +976,12 @@
         {
             int device_id = *((int *)value);
-            if (tls_io_instance->ssl != NULL)
-            {
-                if (tls_io_instance->ssl != NULL && wolfSSL_SetDevId(tls_io_instance->ssl, device_id) != WOLFSSL_SUCCESS)
-                {
-                    LogError("Failure setting device id on ssl");
-                    result = MU_FAILURE;
-                }
-                else
-                {
-                    result = 0;
-                }
+            if (tls_io_instance->ssl != NULL && wolfSSL_SetDevId(tls_io_instance->ssl, device_id) != WOLFSSL_SUCCESS)
+            {
+                LogError("Failure setting device id on ssl");
+                result = MU_FAILURE;
             }
             else
             {
-                // Save the id till we create the ssl object
+                // Save the device Id even if ssl object not yet created.
                 tls_io_instance->wolfssl_device_id = device_id;
                 result = 0;
@@ -964,4 +989,10 @@
         }
 #endif
+        else if (strcmp("ignore_host_name_check", optionName) == 0)
+        {
+            bool* server_name_check = (bool*)value;
+            tls_io_instance->ignore_host_name_check = *server_name_check;
+            result = 0;
+        }
         else
         {
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/crt_abstractions.h
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/crt_abstractions.h	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/crt_abstractions.h	(revision 464)
@@ -6,4 +6,5 @@
 
 #ifdef __cplusplus
+#include <cstdint>
 #include <cstdio>
 #include <cstring>
@@ -11,4 +12,5 @@
 #include <cmath>
 #else // __cplusplus
+#include <stdint.h>
 #include <stdio.h>
 #include <string.h>
@@ -96,4 +98,5 @@
 MOCKABLE_FUNCTION(, int, unsignedIntToString, char*, destination, size_t, destinationSize, unsigned int, value);
 MOCKABLE_FUNCTION(, int, size_tToString, char*, destination, size_t, destinationSize, size_t, value);
+MOCKABLE_FUNCTION(, int, uint64_tToString, char*, destination, size_t, destinationSize, uint64_t, value);
 
 /*following logic shall define the TOUPPER and ISDIGIT, we do that because the SDK is not happy with some Arduino implementation of it.*/
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/sastoken.h
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/sastoken.h	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/sastoken.h	(revision 464)
@@ -4,4 +4,6 @@
 #ifndef SASTOKEN_H
 #define SASTOKEN_H
+
+#include <stdint.h>
 
 #ifdef __cplusplus
@@ -18,6 +20,6 @@
 
     MOCKABLE_FUNCTION(, bool, SASToken_Validate, STRING_HANDLE, sasToken);
-    MOCKABLE_FUNCTION(, STRING_HANDLE, SASToken_Create, STRING_HANDLE, key, STRING_HANDLE, scope, STRING_HANDLE, keyName, size_t, expiry);
-    MOCKABLE_FUNCTION(, STRING_HANDLE, SASToken_CreateString, const char*, key, const char*, scope, const char*, keyName, size_t, expiry);
+    MOCKABLE_FUNCTION(, STRING_HANDLE, SASToken_Create, STRING_HANDLE, key, STRING_HANDLE, scope, STRING_HANDLE, keyName, uint64_t, expiry);
+    MOCKABLE_FUNCTION(, STRING_HANDLE, SASToken_CreateString, const char*, key, const char*, scope, const char*, keyName, uint64_t, expiry);
 
 #ifdef __cplusplus
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/shared_util_options.h
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/shared_util_options.h	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/shared_util_options.h	(revision 464)
@@ -29,4 +29,13 @@
     static STATIC_VAR_UNUSED const char* const OPTION_OPENSSL_CIPHER_SUITE = "CipherSuite";
 
+    static STATIC_VAR_UNUSED const char* const OPTION_OPENSSL_ENGINE = "Engine";
+    static STATIC_VAR_UNUSED const char* const OPTION_OPENSSL_PRIVATE_KEY_TYPE = "x509PrivatekeyType";
+
+    typedef enum OPTION_OPENSSL_KEY_TYPE_TAG
+    {
+        KEY_TYPE_DEFAULT,
+        KEY_TYPE_ENGINE
+    } OPTION_OPENSSL_KEY_TYPE;
+
     static STATIC_VAR_UNUSED const char* const SU_OPTION_X509_CERT = "x509certificate";
     static STATIC_VAR_UNUSED const char* const SU_OPTION_X509_PRIVATE_KEY = "x509privatekey";
@@ -45,5 +54,5 @@
     static STATIC_VAR_UNUSED const char* const OPTION_SET_TLS_RENEGOTIATION = "tls_renegotiation";
 
-    // DEPRECATED: The underlying security library for your platform will use a secure TLS version 
+    // DEPRECATED: The underlying security library for your platform will use a secure TLS version
     // that in general  should not be overridden with OPTION_TLS_VERSION.
     static STATIC_VAR_UNUSED const char* const OPTION_TLS_VERSION = "tls_version";
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/tickcounter.h
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/tickcounter.h	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/inc/azure_c_shared_utility/tickcounter.h	(revision 464)
@@ -18,9 +18,5 @@
 #endif /* __cplusplus */
 
-#if defined(_WIN32) || defined(__MBED__) || defined(__APPLE__)
     typedef uint_fast64_t tickcounter_ms_t; // Use 64-bit because of 32-bit is going to roll over back to zero after roughly 49.7 days that is not good for IoT devices which need keep running for months
-#else
-    typedef uint_fast32_t tickcounter_ms_t;
-#endif
     typedef struct TICK_COUNTER_INSTANCE_TAG *TICK_COUNTER_HANDLE;
 
Index: azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/src/buffer.c
===================================================================
--- azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/src/buffer.c	(revision 457)
+++ azure_iot_hub_f767zi/trunk/azure_iot_sdk/c-utility/src/buffer.c	(revision 464)
@@ -541,8 +541,13 @@
         {
             //put b2 ahead of b1: [b2][b1], return b1
-            if (b2->size ==0)
+            if (b2->size == 0)
             {
                 // do nothing
                 result = 0;
+            }
+            else if (b1->size + b2->size < b2->size)
+            {
+                LogError("Failure: size_t overflow.");
+                result = MU_FAILURE;
             }
             else
